import numpy as np
import scipy.stats as ss
import matplotlib.pyplot as plt

p0 = 0.6            #   真値
NTrials = 2000      #   シミュレーションの試行数
N = 5               #   2項分布の試行数
p_hat_est = []      #   推定値のリスト
    
for t in range(NTrials):
    if (t % 100) == 0:
        print('t = ', t)
    R = np.empty((N), dtype = int)
    for i in range(N):
        if ss.uniform.rvs() < p0:
            R[i] = 1
        else:
            R[i] = 0

    p_hat = R.mean()            #   最尤推定値
    p_hat_est.append(p_hat)

"""
plt.hist(p_hat_est)
plt.show()
"""
#
#           推定値の変換
#
n_p_est = (np.array(p_hat_est) - p0) * (N**0.5)


"""
x_values = np.arange(-2, 2, 0.05)

dfv_norm = ss.norm.pdf(x_values, scale = (p0 * (1.0 - p0)) ** 0.5)

plt.hist(n_p_est, bins = 15, density = True)
plt.plot(x_values, dfv_norm)
plt.show()
"""

n_p_est_s = sorted(n_p_est)     #   累積分布を描くための並べ替え
#
#       累積度数の比率
#
cum_v = (np.arange(0, len(n_p_est_s)) + 1) / len(n_p_est_s)
plt.plot(n_p_est_s, cum_v)
#
#       累積正規分布の描画
#
xvalues_n = np.arange(min(n_p_est_s), max(n_p_est_s), 0.01)
norm_v = ss.norm.cdf(xvalues_n, scale = (p0 * (1.0 - p0)) ** 0.5)
plt.plot(xvalues_n, norm_v)
plt.show()
